# Weapon Upgrading (notched X times)
tag @e[type=item,tag=readyToCraft] remove readyToCraft
execute at @e[type=item,nbt={Item:{tag:{IsSword:1b}}},tag=!cannotForge] if block ~ ~-1 ~ minecraft:anvil as @e[type=item,tag=!cannotForge,distance=..3] at @s if block ~ ~-1 ~ minecraft:anvil run tag @s add readyToCraft
execute as @e[type=item,tag=readyToCraft] store result score @s serrItemCount run data get entity @s Item.Count
execute as @e[type=item,tag=readyToCraft,nbt={Item:{tag:{OreType:0s}}}] at @s[tag=!cannotForge] run scoreboard players operation @p aurCount += @s serrItemCount
execute as @e[type=item,tag=readyToCraft,nbt={Item:{tag:{OreType:1s}}}] at @s[tag=!cannotForge] run scoreboard players operation @p ferCount += @s serrItemCount
execute as @e[type=item,tag=readyToCraft,nbt={Item:{tag:{OreType:2s}}}] at @s[tag=!cannotForge] run scoreboard players operation @p cerCount += @s serrItemCount
execute as @e[type=item,tag=readyToCraft,nbt={Item:{tag:{OreType:3s}}}] at @s[tag=!cannotForge] run scoreboard players operation @p forCount += @s serrItemCount

tag @e[tag=pearlApplying] remove pearlApplying
tag @e[tag=pearlApplyingP] remove pearlApplyingP
execute as @e[type=item,nbt={Item:{Count:1b,tag:{SerrPearl:1b}}}] at @s if block ~ ~-1 ~ minecraft:anvil run tag @s add pearlApplyingP
execute at @e[type=item,tag=pearlApplyingP] as @e[type=item,distance=..2,tag=readyToCraft,nbt={Item:{tag:{IsSword:1b}}}] run tag @s[nbt=!{Item:{tag:{HasPearl:1b}}}] add pearlApplying
execute as @e[type=item,tag=pearlApplying] run data modify entity @s Item.tag.AttributeModifiers append value {Slot:"mainhand",AttributeName:"generic.attack_speed",Name:"generic.attack_speed",Amount:0.2,Operation:0,UUID:[I; -1074440111, 310206542, -1479317077, -1055480912]}
execute as @e[type=item,tag=pearlApplying] run data modify entity @s Item.tag.AttributeModifiers append value {Slot:"mainhand",AttributeName:"generic.attack_damage",Name:"generic.attack_damage",Amount:2,Operation:0,UUID:[I; 190585634, 606448403, -123232036, -1890904599]}
execute as @e[type=item,tag=pearlApplying] run data modify entity @s Item.tag.HasPearl set value 1b
execute as @e[type=item,tag=pearlApplying] run data modify entity @s[nbt={Item:{tag:{Notches:0b}}}] Item.tag.display.Lore[1] set value "[{\"translate\":\"serration.lore.sword.notched0\",\"color\":\"blue\",\"italic\":false},{\"text\":\" \"},{\"translate\":\"serration.lore.sword.pearled\",\"color\":\"blue\",\"italic\":false}]"
execute as @e[type=item,tag=pearlApplying] run data modify entity @s[nbt={Item:{tag:{Notches:1b}}}] Item.tag.display.Lore[1] set value "[{\"translate\":\"serration.lore.sword.notched1\",\"color\":\"blue\",\"italic\":false},{\"text\":\" \"},{\"translate\":\"serration.lore.sword.pearled\",\"color\":\"blue\",\"italic\":false}]"
execute as @e[type=item,tag=pearlApplying] run data modify entity @s[nbt={Item:{tag:{Notches:2b}}}] Item.tag.display.Lore[1] set value "[{\"translate\":\"serration.lore.sword.notched2\",\"color\":\"blue\",\"italic\":false},{\"text\":\" \"},{\"translate\":\"serration.lore.sword.pearled\",\"color\":\"blue\",\"italic\":false}]"
execute as @e[type=item,tag=pearlApplying] run data modify entity @s[nbt={Item:{tag:{Notches:3b}}}] Item.tag.display.Lore[1] set value "[{\"translate\":\"serration.lore.sword.notched3\",\"color\":\"blue\",\"italic\":false},{\"text\":\" \"},{\"translate\":\"serration.lore.sword.pearled\",\"color\":\"blue\",\"italic\":false}]"
execute at @e[type=item,tag=pearlApplying] run playsound minecraft:entity.villager.work_cartographer block @a ~ ~ ~ 2 0
execute at @e[type=item,tag=pearlApplying] run particle minecraft:sweep_attack ~ ~0.5 ~ 0 0 0 1 1 normal
execute as @e[type=item,tag=pearlApplying] run data merge entity @s {PickupDelay:0s}
execute as @e[type=item,tag=pearlApplying] at @s run kill @e[type=item,tag=pearlApplyingP,distance=..3]

tag @e[type=item,tag=notchingUp] remove notchingUp
execute as @e[type=item,tag=!cannotForge,nbt={Item:{tag:{IsSword:1b}}}] at @s run scoreboard players operation @s aurCount = @p[distance=..10] aurCount
execute as @e[type=item,tag=!cannotForge,nbt={Item:{tag:{IsSword:1b}}}] at @s run scoreboard players operation @s ferCount = @p[distance=..10] ferCount
execute as @e[type=item,tag=!cannotForge,nbt={Item:{tag:{IsSword:1b}}}] at @s run scoreboard players operation @s cerCount = @p[distance=..10] cerCount
execute as @e[type=item,tag=!cannotForge,nbt={Item:{tag:{IsSword:1b}}}] at @s run scoreboard players operation @s forCount = @p[distance=..10] forCount
execute as @e[type=item,tag=!cannotForge,nbt={Item:{tag:{IsSword:1b}}}] run scoreboard players set @s largestResCount -1
execute as @e[type=item,tag=!cannotForge,nbt={Item:{tag:{IsSword:1b}}}] if score @s aurCount > @s largestResCount run scoreboard players operation @s largestResCount = @s aurCount
execute as @e[type=item,tag=!cannotForge,nbt={Item:{tag:{IsSword:1b}}}] if score @s ferCount > @s largestResCount run scoreboard players operation @s largestResCount = @s ferCount
execute as @e[type=item,tag=!cannotForge,nbt={Item:{tag:{IsSword:1b}}}] if score @s cerCount > @s largestResCount run scoreboard players operation @s largestResCount = @s cerCount
execute as @e[type=item,tag=!cannotForge,nbt={Item:{tag:{IsSword:1b}}}] if score @s forCount > @s largestResCount run scoreboard players operation @s largestResCount = @s forCount
scoreboard players set @e[type=item,tag=!cannotForge,nbt={Item:{tag:{IsSword:1b}}}] numNeededNotch 999999
scoreboard players set @e[type=item,tag=!cannotForge,nbt={Item:{tag:{IsSword:1b,Notches:0b}}}] numNeededNotch 6
scoreboard players set @e[type=item,tag=!cannotForge,nbt={Item:{tag:{IsSword:1b,Notches:1b}}}] numNeededNotch 9
scoreboard players set @e[type=item,tag=!cannotForge,nbt={Item:{tag:{IsSword:1b,Notches:2b}}}] numNeededNotch 12

tag @a remove isNotching
execute as @e[type=item,tag=!cannotForge,nbt={Item:{tag:{IsSword:1b}}}] at @s[tag=readyToCraft] run tag @a[distance=..5,gamemode=!spectator] add isNotching
execute as @e[type=item,tag=!cannotForge,nbt={Item:{tag:{IsSword:1b}}}] at @s[tag=readyToCraft] run scoreboard players operation @s notchOverLimit = @s largestResCount
execute as @e[type=item,tag=!cannotForge,nbt={Item:{tag:{IsSword:1b}}}] at @s[tag=readyToCraft] run scoreboard players operation @s notchOverLimit -= @s numNeededNotch
execute as @e[type=item,tag=!cannotForge,nbt={Item:{tag:{IsSword:1b}}}] at @s[tag=readyToCraft] run tag @s[scores={notchOverLimit=0..1}] add notchingUp
execute as @e[type=item,tag=!cannotForge,nbt={Item:{tag:{IsSword:1b}}}] at @s[tag=readyToCraft] unless score @s numNeededNotch > 100 Constants unless entity @s[tag=notchingUp] run title @a[distance=..5,gamemode=!spectator] actionbar [{"text":"\ue007 ","color":"white"},{"color":"yellow","score":{"name":"@s","objective":"largestResCount"}},{"color":"yellow","text":"/"},{"color":"yellow","score":{"name":"@s","objective":"numNeededNotch"}}]
execute as @e[type=item,tag=!cannotForge,nbt={Item:{tag:{IsSword:1b}}}] at @s[tag=readyToCraft] if score @s numNeededNotch > 100 Constants unless entity @s[tag=notchingUp] run title @a[distance=..5,gamemode=!spectator] actionbar [{"text":"\ue007 ","color":"white"},{"color":"yellow","translate":"serration.game.notchcap"}]

execute as @e[type=item,tag=readyToCraft] at @s unless entity @e[type=item,distance=..2,tag=notchingUp] run tag @s remove readyToCraft

# Each notch = +1 damage, +0.1 attack speed
execute as @e[type=item,tag=notchingUp,nbt={Item:{tag:{IsSword:1b,Notches:0b}}}] run data modify entity @s Item.tag.AttributeModifiers append value {Slot:"mainhand",AttributeName:"generic.attack_damage",Name:"generic.attack_damage",Amount:1,Operation:0,UUID:[I; 1762330197, -1090351465, 1358420230, 1790266091]}
execute as @e[type=item,tag=notchingUp,nbt={Item:{tag:{IsSword:1b,Notches:0b}}}] run data modify entity @s Item.tag.AttributeModifiers append value {Slot:"mainhand",AttributeName:"generic.attack_speed",Name:"generic.attack_speed",Amount:0.1,Operation:0,UUID:[I; -1843892656, 1989642797, -1887016587, -512911094]}
execute as @e[type=item,tag=notchingUp,scores={aurCount=6..},nbt={Item:{tag:{IsSword:1b,Notches:0b}}}] run data modify entity @s Item.tag merge value {NotchResource0:1s}
execute as @e[type=item,tag=notchingUp,scores={ferCount=6..},nbt={Item:{tag:{IsSword:1b,Notches:0b}}}] run data modify entity @s Item.tag merge value {NotchResource0:2s}
execute as @e[type=item,tag=notchingUp,scores={cerCount=6..},nbt={Item:{tag:{IsSword:1b,Notches:0b}}}] run data modify entity @s Item.tag merge value {NotchResource0:3s}
execute as @e[type=item,tag=notchingUp,scores={forCount=6..},nbt={Item:{tag:{IsSword:1b,Notches:0b}}}] run data modify entity @s Item.tag merge value {NotchResource0:4s}
execute as @e[type=item,tag=notchingUp,nbt={Item:{tag:{IsSword:1b,Notches:0b}}}] run data modify entity @s Item.tag.display.Lore[1] set value "{\"translate\":\"serration.lore.sword.notched1\",\"color\":\"blue\",\"italic\":false}"
execute as @e[type=item,tag=notchingUp,nbt={Item:{tag:{IsSword:1b,Notches:0b,HasPearl:1b}}}] run data modify entity @s Item.tag.display.Lore[1] set value "[{\"translate\":\"serration.lore.sword.notched1\",\"color\":\"blue\",\"italic\":false},{\"text\":\" \"},{\"translate\":\"serration.lore.sword.pearled\",\"color\":\"blue\",\"italic\":false}]"

execute as @e[type=item,tag=notchingUp,nbt={Item:{tag:{IsSword:1b,Notches:1b}}}] run data modify entity @s Item.tag.AttributeModifiers append value {Slot:"mainhand",AttributeName:"generic.attack_damage",Name:"generic.attack_damage",Amount:1,Operation:0,UUID:[I; -717289349, -1256128788, 1248661513, -1897231018]}
execute as @e[type=item,tag=notchingUp,nbt={Item:{tag:{IsSword:1b,Notches:1b}}}] run data modify entity @s Item.tag.AttributeModifiers append value {Slot:"mainhand",AttributeName:"generic.attack_speed",Name:"generic.attack_speed",Amount:0.1,Operation:0,UUID:[I; 1881630905, 2435271, 1066627582, 375483424]}
execute as @e[type=item,tag=notchingUp,scores={aurCount=9..},nbt={Item:{tag:{IsSword:1b,Notches:1b}}}] run data modify entity @s Item.tag merge value {NotchResource1:1s}
execute as @e[type=item,tag=notchingUp,scores={ferCount=9..},nbt={Item:{tag:{IsSword:1b,Notches:1b}}}] run data modify entity @s Item.tag merge value {NotchResource1:2s}
execute as @e[type=item,tag=notchingUp,scores={cerCount=9..},nbt={Item:{tag:{IsSword:1b,Notches:1b}}}] run data modify entity @s Item.tag merge value {NotchResource1:3s}
execute as @e[type=item,tag=notchingUp,scores={forCount=9..},nbt={Item:{tag:{IsSword:1b,Notches:1b}}}] run data modify entity @s Item.tag merge value {NotchResource1:4s}
execute as @e[type=item,tag=notchingUp,nbt={Item:{tag:{IsSword:1b,Notches:1b}}}] run data modify entity @s Item.tag.display.Lore[1] set value "{\"translate\":\"serration.lore.sword.notched2\",\"color\":\"blue\",\"italic\":false}"
execute as @e[type=item,tag=notchingUp,nbt={Item:{tag:{IsSword:1b,Notches:1b,HasPearl:1b}}}] run data modify entity @s Item.tag.display.Lore[1] set value "[{\"translate\":\"serration.lore.sword.notched2\",\"color\":\"blue\",\"italic\":false},{\"text\":\" \"},{\"translate\":\"serration.lore.sword.pearled\",\"color\":\"blue\",\"italic\":false}]"

execute as @e[type=item,tag=notchingUp,nbt={Item:{tag:{IsSword:1b,Notches:2b}}}] run data modify entity @s Item.tag.AttributeModifiers append value {Slot:"mainhand",AttributeName:"generic.attack_damage",Name:"generic.attack_damage",Amount:1,Operation:0,UUID:[I; -717289349, -1256128788, 1248661513, -1897231018]}
execute as @e[type=item,tag=notchingUp,nbt={Item:{tag:{IsSword:1b,Notches:2b}}}] run data modify entity @s Item.tag.AttributeModifiers append value {Slot:"mainhand",AttributeName:"generic.attack_speed",Name:"generic.attack_speed",Amount:0.1,Operation:0,UUID:[I; 1881630905, 2435271, 1066627582, 375483424]}
execute as @e[type=item,tag=notchingUp,scores={aurCount=12..},nbt={Item:{tag:{IsSword:1b,Notches:2b}}}] run data modify entity @s Item.tag merge value {NotchResource2:1s}
execute as @e[type=item,tag=notchingUp,scores={ferCount=12..},nbt={Item:{tag:{IsSword:1b,Notches:2b}}}] run data modify entity @s Item.tag merge value {NotchResource2:2s}
execute as @e[type=item,tag=notchingUp,scores={cerCount=12..},nbt={Item:{tag:{IsSword:1b,Notches:2b}}}] run data modify entity @s Item.tag merge value {NotchResource2:3s}
execute as @e[type=item,tag=notchingUp,scores={forCount=12..},nbt={Item:{tag:{IsSword:1b,Notches:2b}}}] run data modify entity @s Item.tag merge value {NotchResource2:4s}
execute as @e[type=item,tag=notchingUp,nbt={Item:{tag:{IsSword:1b,Notches:2b}}}] run data modify entity @s Item.tag.display.Lore[1] set value "{\"translate\":\"serration.lore.sword.notched3\",\"color\":\"blue\",\"italic\":false}"
execute as @e[type=item,tag=notchingUp,nbt={Item:{tag:{IsSword:1b,Notches:2b,HasPearl:1b}}}] run data modify entity @s Item.tag.display.Lore[1] set value "[{\"translate\":\"serration.lore.sword.notched3\",\"color\":\"blue\",\"italic\":false},{\"text\":\" \"},{\"translate\":\"serration.lore.sword.pearled\",\"color\":\"blue\",\"italic\":false}]"

execute at @e[type=item,tag=notchingUp] run playsound minecraft:entity.villager.work_cartographer block @a ~ ~ ~ 2 0
execute at @e[type=item,tag=notchingUp] run particle minecraft:sweep_attack ~ ~0.5 ~ 0 0 0 1 1 normal
execute as @e[type=item,tag=notchingUp] run data merge entity @s {PickupDelay:0s}
execute as @e[type=item,tag=notchingUp] store result score @s temp1 run data get entity @s Item.tag.Notches
execute as @e[type=item,tag=notchingUp] run scoreboard players add @s temp1 1
execute as @e[type=item,tag=notchingUp] store result entity @s Item.tag.Notches byte 1 run scoreboard players get @s temp1
kill @e[type=item,tag=readyToCraft,nbt=!{Item:{tag:{IsSword:1b}}}]
